package com.hotwj.platform.config.accidentLikelihoodLevelConfig.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.hotwj.platform.config.accidentLikelihoodLevelConfig.domain.HotAccidentLikelihoodLevelConfig;
import com.hotwj.platform.config.accidentLikelihoodLevelConfig.domain.bo.HotAccidentLikelihoodLevelConfigBo;
import com.hotwj.platform.config.accidentLikelihoodLevelConfig.domain.vo.HotAccidentLikelihoodLevelConfigVo;
import com.hotwj.platform.config.accidentLikelihoodLevelConfig.mapper.HotAccidentLikelihoodLevelConfigMapper;
import com.hotwj.platform.config.accidentLikelihoodLevelConfig.service.IHotAccidentLikelihoodLevelConfigService;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.PageQuery;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.springframework.stereotype.Service;

import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * 事故等级划分（可能性）Service业务层处理
 *
 * @author shihongwei
 * @date 2026-01-05
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class HotAccidentLikelihoodLevelConfigServiceImpl implements IHotAccidentLikelihoodLevelConfigService {

    private final HotAccidentLikelihoodLevelConfigMapper baseMapper;

    /**
     * 查询事故等级划分（可能性）
     *
     * @param id 主键
     * @return 事故等级划分（可能性）
     */
    @Override
    public HotAccidentLikelihoodLevelConfigVo queryById(Long id) {
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询事故等级划分（可能性）列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 事故等级划分（可能性）分页列表
     */
    @Override
    public TableDataInfo<HotAccidentLikelihoodLevelConfigVo> queryPageList(HotAccidentLikelihoodLevelConfigBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<HotAccidentLikelihoodLevelConfig> lqw = buildQueryWrapper(bo);
        Page<HotAccidentLikelihoodLevelConfigVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的事故等级划分（可能性）列表
     *
     * @param bo 查询条件
     * @return 事故等级划分（可能性）列表
     */
    @Override
    public List<HotAccidentLikelihoodLevelConfigVo> queryList(HotAccidentLikelihoodLevelConfigBo bo) {
        LambdaQueryWrapper<HotAccidentLikelihoodLevelConfig> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<HotAccidentLikelihoodLevelConfig> buildQueryWrapper(HotAccidentLikelihoodLevelConfigBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<HotAccidentLikelihoodLevelConfig> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(HotAccidentLikelihoodLevelConfig::getId);
        lqw.eq(bo.getLevelValue() != null, HotAccidentLikelihoodLevelConfig::getLevelValue, bo.getLevelValue());
        lqw.eq(StringUtils.isNotBlank(bo.getCriterion()), HotAccidentLikelihoodLevelConfig::getCriterion, bo.getCriterion());
        lqw.eq(bo.getIsDeleted() != null, HotAccidentLikelihoodLevelConfig::getIsDeleted, bo.getIsDeleted());
        return lqw;
    }

    /**
     * 新增事故等级划分（可能性）
     *
     * @param bo 事故等级划分（可能性）
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(HotAccidentLikelihoodLevelConfigBo bo) {
        HotAccidentLikelihoodLevelConfig add = MapstructUtils.convert(bo, HotAccidentLikelihoodLevelConfig.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改事故等级划分（可能性）
     *
     * @param bo 事故等级划分（可能性）
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(HotAccidentLikelihoodLevelConfigBo bo) {
        HotAccidentLikelihoodLevelConfig update = MapstructUtils.convert(bo, HotAccidentLikelihoodLevelConfig.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(HotAccidentLikelihoodLevelConfig entity) {
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除事故等级划分（可能性）信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if (isValid) {
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
